
#include <pthread.h>

#include "mammut.h"
#include "play.h"

pthread_t pthread={0};
bool thread_is_joinable=false;
bool dontstop=true;

void PlayWaveConsumer(
		      void *port,
		      float **samples,
		      int num_samples
		      )
{
  if(dontstop==false) return;
  WritePlay(port,samples,num_samples);
}

void PlayStopHard(void){
  dontstop=false;

  if(thread_is_joinable==true){
    pthread_join(pthread,NULL);
  }
}

void PlayStop(void){
  dontstop=false;
}

void *DoPlay(void *port){

  thread_is_joinable=true;

  writesound(PlayWaveConsumer,port);
  
  ClosePlay(port);
  
  //  for (i=0; i<samps_per_frame*N; i++) lyd[i]=lyd2[i];
  memcpy(lyd,lyd2,samps_per_frame*N*sizeof(float));
	 
  return NULL;
}


void Play(void)
{

  void *port;
  int ch;

  if(lyd==NULL) return;

  PlayStopHard();

  if(InitPlay()==false) return;

  port=OpenPlay(samps_per_frame,R);

  if(port==NULL) return;

  //  for (i=0; i<samps_per_frame*N; i++) lyd2[i]=lyd[i];
  memcpy(lyd2,lyd,samps_per_frame*N*sizeof(float));

  for (ch=0; ch<samps_per_frame; ch++) {
    rfft(lyd+ch*N,  N/2,  INVERSE);
  }

  dontstop=true;

  if(pthread_create(&pthread,NULL,DoPlay,port)!=0){
    fprintf(stderr,"Could not make pthread.\n");
  }

}

